function [hat_x,info] = alg_rLSAPC_intervals(y,M,krok)
% rekurzive LSAPCi 

[p,n] = size(M);

%% set L_low a L_high a hat_L0
Llow = zeros(n);
Lhigh = zeros(n);
indL = zeros(n); % auxiliary
eL0 = zeros(n);

% settings relevant to studied case release
% for other configuration, it needs to be rearanged
if n==224 
    nuks = 16;
    % load xt (x_true), only for ratios and intervals calculation
    load('./data/xt.mat','xt')
    
    % reordering
    ind = [];
    for i = 1:16
        ind = [ind i:16:n]; 
    end
    xt = xt(ind);
    % the first nuclide is set as the x_m
    M = M(:,[15:end 1:14]);
    xt = xt([15:end 1:14]);
    
    indL = zeros(n);
    indL(211:224,1:210) = kron(ones(1,15),eye(14));


    x1 = xt((n-14+1):n);
    pom = -xt./kron(ones(16,1),x1); % elements of the matrix L
    pom(isnan(pom)) = 0;

    for i = 1:15
        pomi = pom( ((i-1)*14+1) : ((i-1)*14+14) );
        pomi(pomi==0) = 1.0*mean(pomi(pomi~=0));
        lowpomi = 2.5*(pomi); %2.5 % otocene protoze znamenko minus u pom
        highpomi = 0.5*(pomi); %0.5

        Llow((end-14+1):(end),(1+(i-1)*14):(14+(i-1)*14)) = diag(lowpomi);
        Lhigh((end-14+1):(end),(1+(i-1)*14):(14+(i-1)*14)) = diag(highpomi);
    end

    indL(211:224,211:224) = diag(ones(14-1,1),-1);
    eL0(211:224,211:224) = diag(-ones(14-1,1),-1);

end

hat_x = zeros(n,1);
hat_upsilon = zeros(n,1);

for i=1:((n/nuks)-krok+1) % iterations over steps (only 1 iteration if window_size = 14)
    
    switch 1
        case 1 % receding (moving) window
            ind = [];
            for j = 1:nuks
                ind = [ind ( (j-1)*(n/nuks) + (i:(i+krok-1)))];
            end
        case 2 % time-interval increasing with incoming measurements
            ind = [];
            for j=1:nuks
                ind = [ind ( ((j-1)*(n/nuks)+1):((j-1)*(n/nuks)+krok+(i-1)) )];
            end
    end

    if i==1 % initialization of x a upsilon
        hat_omega = 1*max(max(M(:,ind)'*M(:,ind)))^(-1);
        hat_upsilon(ind) = ones(size(ind,2),1);
        
        si_x = (hat_omega*M(:,ind)'*M(:,ind) + eye(size(hat_upsilon(ind),1))*diag(hat_upsilon(ind))*eye(size(hat_upsilon(ind),1))' + eye(size(hat_upsilon(ind),1)) )^(-1);
        mu_x = si_x*(hat_omega*M(:,ind)'*y);

        [hat_x(ind) hat_xx] = momtrun_low(mu_x,sqrt(diag( si_x )),0);
    end

    % run algorithm on indexes "ind"
    [x_temp,info_temp] = alg_rLSAPCi_inner(y,M(:,ind),hat_x(ind),nuks,Llow(ind,ind),Lhigh(ind,ind),indL(ind,ind),eL0(ind,ind),100,hat_upsilon(ind));
    hat_x(ind) = x_temp;
    hat_upsilon(ind) = info_temp.ups;
end

% reverse reordering of results (for print)

info.ups = hat_upsilon([(end-14+1):end 1:(end-14)]);
info.mux = info_temp.mux([(end-14+1):end 1:(end-14)]);
dsix = diag(info_temp.six);
dsix = dsix([(end-14+1):end 1:(end-14)]);
info.dsix = dsix;
hat_x = hat_x([(end-14+1):end 1:(end-14)]); 


end
